#pragma once

#include "LightSource.h"

class DirectionalLight : public LightSource
{
public:
	DirectionalLight()
		: LightSource()
	{
	}

	DirectionalLight(const MyAlgebra::vec3 &d, const MyAlgebra::vec3 &c)
		: dir(d), LightSource(c)
	{
	}

	DirectionalLight(const DirectionalLight &d)
		: dir(d.dir), LightSource(d.m_Color)
	{
	}

	void calcLightInfo(const MyAlgebra::vec3 &hitPos, LightInfo &info) const
	{
		info.dir = dir;
		info.color = m_Color;
		info.dist = (MyAlgebra::Real)1.0e+23;	// inf
	}

	Light_Type getLightType() const { return Directional_Light; }

private:
	MyAlgebra::vec3 dir;
};
