#pragma once

#include "LightSource.h"

// Almost the same as "DirectionalLight.h"

class EnvironmentLight : public LightSource
{
public:
	static float s_LuminanceScaleCoefficient;

	EnvironmentLight()
		: LightSource()
	{
	}

	EnvironmentLight(const MyAlgebra::vec3 &d, const MyAlgebra::vec3 &c)
		: m_Direction(d), LightSource(c)
	{
	}

	EnvironmentLight(const EnvironmentLight &d)
		: m_Direction(d.m_Direction), LightSource(d.m_Color)
	{
	}

	void calcLightInfo(const MyAlgebra::vec3 &hitPos, LightInfo &info) const
	{
		info.dir = m_Direction;
		info.color = s_LuminanceScaleCoefficient * m_Color;
		info.dist = (MyAlgebra::Real)1.0e+23;	// inf
	}

	Light_Type getLightType() const { return Environment_Light; }

private:
	MyAlgebra::vec3 m_Direction;
};
