#include "GeometryInstance.h"
#include <cstdlib>
#include <GL/glut.h>

using namespace std;
using namespace MyAlgebra;

bool GeometryInstance::hit(const Ray &r, Real tmin, Real tmax, HitRecord &record) const
{
	vec3 origin = r.getOrigin();
	vec3 dir = r.getUnitDir();

	// TODO: transform origin and dir

	Ray transformedRay( origin, dir );

	const bool isHit = m_pObject->hit(transformedRay, tmin, tmax, record);

	if (isHit)
	{
		// TODO: transform record.normal and modify record.t

		record.hit_pos = r.getPosition( record.t );

		record.material = material;
	}

	return isHit;
}

bool GeometryInstance::shadowHit(const Ray &r, Real tmin, Real tmax) const
{
	vec3 origin = r.getOrigin();
	vec3 dir = r.getUnitDir();

	// TODO: transform origin and dir

	Ray transformedRay( origin, dir );

	const bool isHit = m_pObject->shadowHit(transformedRay, tmin, tmax);

	return isHit;
}

void GeometryInstance::drawGL() const
{
	mat4 transformMatrix = m_InverseTransformMatrix;
	transformMatrix.invert();

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glMultMatrixf( transformMatrix.mat_array );

	m_pObject->drawGL();

	glPopMatrix();
}

GeometryInstance & GeometryInstance::transform( const vec4 &col0, const vec4 &col1, const vec4 &col2, const vec4 &col3 )
{
	// TODO: fill here

	return *this;
}

GeometryInstance & GeometryInstance::transform( const mat4 &M )
{
	// TODO: fill here

	return *this;
}

GeometryInstance & GeometryInstance::translate( float x, float y, float z )
{
	// TODO: fill here

	return *this;
}

GeometryInstance & GeometryInstance::translate( const vec3 &t )
{
	// TODO: fill here

	return *this;
}

GeometryInstance & GeometryInstance::scale( float sx, float sy, float sz )
{
	// TODO: fill here

	return *this;
}

GeometryInstance & GeometryInstance::rotate( float angle, float x, float y, float z )
{
	// TODO: fill here

	return *this;
}

