#pragma once

#include "my_algebra.h"

struct LightInfo
{
	MyAlgebra::vec3 dir;
	MyAlgebra::vec3 color;
	MyAlgebra::Real dist;
};

class LightSource
{
public:
	enum Light_Type
	{
		No_Light,
		Point_Light,
		Directional_Light,
		Environment_Light,
	};

	LightSource()
		: m_Color(1,1,1)
	{
	}

	LightSource(const MyAlgebra::vec3 &c)
		: m_Color(c)
	{
	}

	LightSource(const LightSource& l)
		: m_Color(l.m_Color)
	{
	}

	virtual ~LightSource()
	{
	}

	void setColor(const MyAlgebra::vec3& c) { m_Color = c; }

	virtual void calcLightInfo(const MyAlgebra::vec3 &hitPos, LightInfo &info) const = 0;

	virtual Light_Type getLightType() const { return No_Light; }

protected:
	MyAlgebra::vec3 m_Color;

};
