#include "MetaballSurface.h"
#include "SphereIntersectionInfo.h"
#include "RecursiveBezierClipping2.h"

#include <algorithm>

#include <cstdlib>
#include <GL/glut.h>

using namespace std;
using namespace MyAlgebra;

bool MetaballSurface::hit(const Ray &ray, Real tmin, Real tmax, HitRecord &record) const
{
	const vec3 &origin = ray.getOrigin();
	const vec3 &dir = ray.getUnitDir();

	// CƁAׂẴ^{[̃oEfBOƂ̌_ۑ

	vector<SphereIntersectionInfo> sphereIntersections;

	// C̎n_܂悤ȋ̃Xg 
	vector<int> metaballIDs;

	for (int mi=0; mi<(int)m_Metaballs.size(); mi++)
	{
		// TODO: fill here
	}

	// 鋅Ȃ΁A̎_Ń^{[Ƃ̌͂Ȃ 

	if (sphereIntersections.empty())
		return false;

	// _߂ (C̃p[^ t ) Ɍ_בւ 

	sort(sphereIntersections.begin(), sphereIntersections.end());

	// \[gꂽƃCƂ̌_̂AA 2 ̌_̊Ԃ̋ԂŁAlʂƂ̌_Ȃ 
	// lʂ̌Ɋ֗^郁^{[̔zpӂA_ł̃^{[ ID 邽т
	// ̔zXV (z ID łɂΔz񂩂폜AȂΒǉ)

	float tCurrent = 0.001f;

	for (int i=0; i<(int)sphereIntersections.size(); i++)
	{
		const float tNew = sphereIntersections[i].m_ParamT;

		// lʂ̌Ɋ֗^郁^{[̐ 
		const int nParticipants = (int)metaballIDs.size();

		if (nParticipants == 1)	// lʂ͋ɂȂA^{[Ƌ̌
		{
			// TODO: fill here
		}
		else if (nParticipants >= 2)
		{
			const int equationDegree = 6;
			const float g_Threshold = 0.5f;
			const float g_Intensity = 1.f;

			// Bezier Clipping ɂ̂߂̌W̐ݒ

			float metaballCoeffs[equationDegree+1];

			for (int i=0; i<=equationDegree; i++)
				metaballCoeffs[i] = -g_Threshold;

			for (int mi=0; mi<nParticipants; mi++)
			{
				const Metaball &m = m_Metaballs[ metaballIDs[mi] ];
				const float R = m.getRadius();

				const vec3 v = origin - m.getCenter();

				const float b = dot(v, dir);
				const float c = v.sq_norm() - R*R;

				//const float D = max(1.e-16f, b*b - c);
				const float D = b*b - c;

				const float sqrtD = sqrtf(D);
				const float a = D / (R*R);

				const float _tMin = -b - sqrtD;

				const float t0 = 0.5f * (tCurrent - _tMin) / sqrtD;
				const float t1 = 0.5f * (tNew - _tMin) / sqrtD;

				float tmpCoeffs[equationDegree+1];
				calculateMetaballBezierCoeffs(g_Intensity, a, t0, t1, tmpCoeffs);

				for (int di=0; di<=equationDegree; di++)
					metaballCoeffs[di] += tmpCoeffs[di];
			}

			BezierClipping<equationDegree> finder;
			finder.initWithBezierCoeffs(metaballCoeffs);
			const float root = finder.findSmallestRoot();

			// H
			if (0.f < root && root < 1.f)
			{
				const float tIntersect = (tNew - tCurrent) * root + tCurrent;

				//if ( tCurrent <= tIntersect && tIntersect <= tNew && s_EpsilonParamT <= tIntersect && tIntersect <= s_InfinityParamT )
				if ( tCurrent <= tIntersect && tIntersect <= tNew)
				{
					const vec3 pIntersect = origin + tIntersect * dir;

					// @̌vZ 

					vec3 grad(0,0,0);

					for (int mi=0; mi<nParticipants; mi++)
					{
						const Metaball &m = m_Metaballs[ metaballIDs[mi] ];

						const float r = m.getRadius();
						const float r2 = r*r;

						const vec3 v = pIntersect - m.getCenter();

						const float R2 = v.sq_norm() / r2;
						const float df = -2.f * ( (-4.f/3.f*R2 + 34.f/9.f)*R2 - 22.f/9.f ) / r2;

						const float intensity = g_Intensity;

						grad += intensity * df * v;
					}

					record.t = tIntersect;
					record.hit_pos = pIntersect;
					record.normal = normalize(grad);
					record.material = material;

					return true;
				}
			}
		}

		// Ȃ̂Ŏ̌_ɐi

		tCurrent = tNew;

		const int idNew = sphereIntersections[i].m_MetaballID;

		// z idNew łɂΔz񂩂폜AȂΒǉ

		vector<int>::const_iterator itr = find(metaballIDs.begin(), metaballIDs.end(), idNew);

		if (itr == metaballIDs.end()) // zɂȂ
		{
			metaballIDs.push_back( idNew );
		}
		else
		{
			metaballIDs.erase( itr );
		}
	}

	return false;
}

bool MetaballSurface::shadowHit(const Ray &ray, Real tmin, Real tmax) const
{
	const vec3 &origin = ray.getOrigin();
	const vec3 &dir = ray.getUnitDir();

	// CƁAׂẴ^{[̃oEfBOƂ̌_ۑ

	vector<SphereIntersectionInfo> sphereIntersections;

	// C̎n_܂悤ȋ̃Xg 
	vector<int> metaballIDs;

	for (int mi=0; mi<(int)m_Metaballs.size(); mi++)
	{
		// TODO: fill here
	}

	// 鋅Ȃ΁A̎_Ń^{[Ƃ̌͂Ȃ 

	if (sphereIntersections.empty())
		return false;

	// _߂ (C̃p[^ t ) Ɍ_בւ 

	sort(sphereIntersections.begin(), sphereIntersections.end());

	// \[gꂽƃCƂ̌_̂AA 2 ̌_̊Ԃ̋ԂŁAlʂƂ̌_Ȃ 
	// lʂ̌Ɋ֗^郁^{[̔zpӂA_ł̃^{[ ID 邽т
	// ̔zXV (z ID łɂΔz񂩂폜AȂΒǉ)

	float tCurrent = 0.001f;

	for (int i=0; i<(int)sphereIntersections.size(); i++)
	{
		const float tNew = sphereIntersections[i].m_ParamT;

		// lʂ̌Ɋ֗^郁^{[̐ 
		const int nParticipants = (int)metaballIDs.size();

		if (nParticipants == 1)	// lʂ͋ɂȂA^{[Ƌ̌
		{
			// TODO: fill here
		}
		//else if ( 0 )
		else if (nParticipants >= 2)
		{
			const int equationDegree = 6;
			const float g_Threshold = 0.5f;
			const float g_Intensity = 1.f;

			// Bezier Clipping ɂ̂߂̌W̐ݒ

			float metaballCoeffs[equationDegree+1];

			for (int i=0; i<=equationDegree; i++)
				metaballCoeffs[i] = -g_Threshold;

			for (int mi=0; mi<nParticipants; mi++)
			{
				const Metaball &m = m_Metaballs[ metaballIDs[mi] ];
				const float R = m.getRadius();

				const vec3 v = origin - m.getCenter();

				const float b = dot(v, dir);
				const float c = v.sq_norm() - R*R;

				//const float D = max(1.e-16f, b*b - c);
				const float D = b*b - c;

				const float sqrtD = sqrtf(D);
				const float a = D / (R*R);

				const float _tMin = -b - sqrtD;

				const float t0 = 0.5f * (tCurrent - _tMin) / sqrtD;
				const float t1 = 0.5f * (tNew - _tMin) / sqrtD;

				float tmpCoeffs[equationDegree+1];
				calculateMetaballBezierCoeffs(g_Intensity, a, t0, t1, tmpCoeffs);

				for (int di=0; di<=equationDegree; di++)
					metaballCoeffs[di] += tmpCoeffs[di];
			}

			BezierClipping<equationDegree> finder;
			finder.initWithBezierCoeffs(metaballCoeffs);
			const float root = finder.findSmallestRoot();

			// H
			if (0.f < root && root < 1.f)
			{
				const float tIntersect = (tNew - tCurrent) * root + tCurrent;

				//if ( tCurrent <= tIntersect && tIntersect <= tNew && s_EpsilonParamT <= tIntersect && tIntersect <= s_InfinityParamT )
				if ( tCurrent <= tIntersect && tIntersect <= tNew)
				{
					return true;
				}
			}
		}

		// Ȃ̂Ŏ̌_ɐi

		tCurrent = tNew;

		const int idNew = sphereIntersections[i].m_MetaballID;

		// z idNew łɂΔz񂩂폜AȂΒǉ

		vector<int>::const_iterator itr = find(metaballIDs.begin(), metaballIDs.end(), idNew);

		if (itr == metaballIDs.end()) // zɂȂ
		{
			metaballIDs.push_back( idNew );
		}
		else
		{
			metaballIDs.erase( itr );
		}
	}

	return false;
}

void MetaballSurface::drawGL() const
{
	for (int i=0; i<(int)m_Metaballs.size(); i++)
	{
		const Metaball &m = m_Metaballs[i];
		const vec3 center = m.getCenter();
		const float radius = m.getRadius();

		glPushMatrix();
		glTranslatef( center.x, center.y, center.z );
		glutSolidSphere( radius, 32, 32 );
		glPopMatrix();
	}
}

// private functions

void MetaballSurface::calculateMetaballBezierCoeffs(float intensity, float a, float t0, float t1, float *coeffs) const
{
	const int degree = 6;

	const float a2 = a*a;

	coeffs[0] = 0.f;
	coeffs[1] = 0.f;
	coeffs[2] = intensity * (16.f/27.f) * a2;
	coeffs[3] = intensity * 8.f * (8.f*a + 5.f) * a2 / 45.f;
	coeffs[4] = coeffs[2];
	coeffs[5] = 0.f;
	coeffs[6] = 0.f;

	if (t0 > 1.0e-6f)
	{
		for (int i=1; i<=degree; i++)
			for (int j=0; j<=degree-i; j++)
				coeffs[j] += (coeffs[j+1] - coeffs[j]) * t0;
	}

	const float t01 = (1.f - t1) / (1.f - t0);

	if (t01 > 1.0e-6f)
	{
		for (int i=1; i<=degree; i++)
			for (int j=degree; j>=i; j--)
				coeffs[j] += (coeffs[j-1] - coeffs[j]) * t01;
	}
}
