#include "MiscSettings.h"
#include "Material.h"
#include "Filter.h"
#include "SingleSampler.h"

using namespace std;
using namespace MyAlgebra;

void MiscSettings::init()
{
	m_KeepRayTracing = 0;
	m_DumpComputationTime = 1;

	m_RecursionDepth = 4;

	m_SceneFilename = "default.cfg";
	m_ScreenshotFilename = "screenshot.jpg";
	m_SceneVerboseLoad = 0;

	//m_CameraPosition = vec3(0,0,1);
	//m_CameraCenter = vec3(0,0,0);
	//m_CameraUpDir = vec3(0,1,0);
	m_Modelview = mat4( 1, 0, 0, 0,
		0, 1, 0, 0,
		0, 0, 1, 0, 
		0, 0, -1, 1);
	m_CameraFovy = 30.f;

	m_ScreenWidth = 400;
	m_ScreenHeight = 300;

	m_PixelFilterType = Filter::Box_Filter;
	m_pSampler = SingleSampler::Create();

	m_EnvironmentMapFilename = "";
	m_HdrGamma = 0.5f;
	m_NumIblSamples = 256;
	m_IblLightScale = 0.001f / m_NumIblSamples;

	Material *ambient = Material::CreateMaterial();
	ambient->setAmbientCoeff( 0.5f, 0.5f, 0.5f );

	m_pDefaultMaterial = ambient;
}
