#pragma once

#include <string>
#include "my_algebra.h"

#include "Sampler.h"
#include "Material.h"

struct MiscSettings
{
	MiscSettings()
		: m_pSampler(0), m_pDefaultMaterial(0)
	{
	}

	~MiscSettings()
	{
	}

	int m_KeepRayTracing;
	int m_DumpComputationTime;

	int m_RecursionDepth;

	std::string m_SceneFilename;
	std::string m_ScreenshotFilename;

	int m_SceneVerboseLoad;

	//MyAlgebra::vec3 m_CameraPosition;
	//MyAlgebra::vec3 m_CameraCenter;
	//MyAlgebra::vec3 m_CameraUpDir;
	MyAlgebra::mat4 m_Modelview;
	float m_CameraFovy;

	int m_ScreenWidth;
	int m_ScreenHeight;

	int m_PixelFilterType;
	Sampler *m_pSampler;

	std::string m_EnvironmentMapFilename;
	float m_HdrGamma;
	int m_NumIblSamples;
	float m_IblLightScale;

	Material *m_pDefaultMaterial;

	void init();
};

