#include "OGLBaseWindow.h"
#include <iostream>

using namespace std;

std::vector<OGLBaseWindow *> OGLBaseWindow::s_WindowsArray;

void OGLBaseWindow::Display()
{
	const int winID = glutGetWindow();
	for (unsigned int i=0; i<s_WindowsArray.size(); ++i)
	{
		if (winID == s_WindowsArray[i]->getWindowID())
		{
			s_WindowsArray[i]->display();
			break;
		}
	}
}

void OGLBaseWindow::Reshape(int w, int h)
{
	const int winID = glutGetWindow();
	for (unsigned int i=0; i<s_WindowsArray.size(); ++i)
	{
		if (winID == s_WindowsArray[i]->getWindowID())
		{
			s_WindowsArray[i]->reshape(w, h);
			glutPostRedisplay();
			break;
		}
	}
}

void OGLBaseWindow::Keyboard(unsigned char key, int x, int y)
{
	if (key == 'q' || key == 'Q' || key == '\033')
		exit(0);

	const int winID = glutGetWindow();
	for (unsigned int i=0; i<s_WindowsArray.size(); ++i)
	{
		if (winID == s_WindowsArray[i]->getWindowID())
		{
			s_WindowsArray[i]->keyboard(key, x, y);
			glutPostRedisplay();
			break;
		}
	}
}

void OGLBaseWindow::Special(int key, int x, int _y)
{
	const int winID = glutGetWindow();
	for (unsigned int i=0; i<s_WindowsArray.size(); ++i)
	{
		if (winID == s_WindowsArray[i]->getWindowID())
		{
			s_WindowsArray[i]->special(key, x, _y);
			glutPostRedisplay();
			break;
		}
	}
}

void OGLBaseWindow::Mouse(int button, int state, int x, int _y)
{
	const int winID = glutGetWindow();
	for (unsigned int i=0; i<s_WindowsArray.size(); ++i)
	{
		if (winID == s_WindowsArray[i]->getWindowID())
		{
			s_WindowsArray[i]->mouse(button, state, x, _y);
			glutPostRedisplay();
			break;
		}
	}
}

void OGLBaseWindow::Passive(int x, int _y)
{
	const int winID = glutGetWindow();
	for (unsigned int i=0; i<s_WindowsArray.size(); ++i)
	{
		if (winID == s_WindowsArray[i]->getWindowID())
		{
			s_WindowsArray[i]->passive(x, _y);
			glutPostRedisplay();
			break;
		}
	}
}

void OGLBaseWindow::Motion(int x, int _y)
{
	const int winID = glutGetWindow();
	for (unsigned int i=0; i<s_WindowsArray.size(); ++i)
	{
		if (winID == s_WindowsArray[i]->getWindowID())
		{
			s_WindowsArray[i]->motion(x, _y);
			glutPostRedisplay();
			break;
		}
	}
}

void OGLBaseWindow::Menu(int item)
{
	const int winID = glutGetWindow();
	for (unsigned int i=0; i<s_WindowsArray.size(); ++i)
	{
		if (winID == s_WindowsArray[i]->getWindowID())
		{
			s_WindowsArray[i]->menu(item);
		}
	}
}

void OGLBaseWindow::Idle()
{
	for (unsigned int i=0; i<s_WindowsArray.size(); ++i)
	{
		glutSetWindow( s_WindowsArray[i]->getWindowID() );
		s_WindowsArray[i]->display();
		glutPostRedisplay();
	}
}
