#pragma once

#include "Material.h"

class PerfectSpecularMaterial : public Material
{
private:
	PerfectSpecularMaterial()
		: ks(1,1,1)
	{
	}

	PerfectSpecularMaterial(const PerfectSpecularMaterial &m)
		: ks(m.ks), Material(m)
	{
	}

public:
	static PerfectSpecularMaterial *CreateMaterial()
	{
		PerfectSpecularMaterial *m = new PerfectSpecularMaterial();
		material_cache.push_back( m );
		return m;
	}

	static PerfectSpecularMaterial *CreateMaterial(const PerfectSpecularMaterial *_m)
	{
		PerfectSpecularMaterial *m = new PerfectSpecularMaterial(*_m);
		material_cache.push_back( m );
		return m;
	}

	~PerfectSpecularMaterial()
	{
	}

	Material_Type getMaterialType() const { return Perfect_Specular_Type; }

	//MyAlgebra::vec3 calcReflectedLight(
	//	const MyAlgebra::vec3 &normal,
	//	const MyAlgebra::vec3 &incomingDir,
	//	const MyAlgebra::vec3 &outgoingDir) const
	//{
	//	return MyAlgebra::vec3();
	//}

	void clone(Material **m) const { *m = new PerfectSpecularMaterial(*this); }

	MyAlgebra::vec3 getSpecularCoeff() const { return ks; }
	void setSpecularCoeff(const MyAlgebra::vec3 &k) { ks = k; }
	void setSpecularCoeff(MyAlgebra::Real r, MyAlgebra::Real g, MyAlgebra::Real b) { ks.set(r,g,b); }

private:
	MyAlgebra::vec3 ks;	// specular

};
