#pragma once

#include "Material.h"

class PhongMaterial : public Material
{
private:
	PhongMaterial()
		: shininess(32), ks(1,1,1), kd(1,1,1)
	{
	}

	PhongMaterial(const PhongMaterial &m)
		: shininess(m.shininess), ks(m.ks), kd(m.kd), Material(m)
	{
	}

public:
	static PhongMaterial *CreateMaterial()
	{
		PhongMaterial *m = new PhongMaterial();
		material_cache.push_back( m );
		return m;
	}

	static PhongMaterial *CreateMaterial(const PhongMaterial *_m)
	{
		PhongMaterial *m = new PhongMaterial(*_m);
		material_cache.push_back( m );
		return m;
	}

	~PhongMaterial()
	{
	}

	Material_Type getMaterialType() const { return Phong_Type; }

	vec3 calcReflectedLight(const HitRecord &record, const vec3 &incomingDir, const vec3 &outgoingDir) const
	{
		// TODO: rewrite this function
		// normal can be obtained via record.normal

		return vec3(0.f);
	}

	Real getShininess() const { return shininess; }
	void setShininess(Real s) { shininess = s; }

	vec3 getPhongCoeff() const { return ks; }
	void setPhongCoeff(const vec3 &k) { ks = k; }
	void setPhongCoeff(Real r, Real g, Real b) { ks.set(r,g,b); }

	vec3 getDiffuseCoeff() const { return kd; }
	void setDiffuseCoeff(const vec3 &k) { kd = k; }
	void setDiffuseCoeff(Real r, Real g, Real b) { kd.set(r,g,b); }

private:
	Real shininess; // power of cosine lobe
	vec3 ks;	// phong
	vec3 kd;	// diffuse

};
