#pragma once

#include "LightSource.h"

class PointLight : public LightSource
{
public:
	PointLight()
		: LightSource()
	{
	}

	PointLight(const MyAlgebra::vec3 &p, const MyAlgebra::vec3 &c)
		: pos(p), LightSource(c)
	{
	}

	MyAlgebra::vec3 getPos() const { return pos; }
	void setPos(const MyAlgebra::vec3& p) { pos = p; }

	void calcLightInfo(const MyAlgebra::vec3 &hitPos, LightInfo &info) const
	{
		MyAlgebra::vec3 v = pos - hitPos;
		const MyAlgebra::Real sqrDist = v.sq_norm();
		info.color = m_Color / sqrDist;
		info.dist = sqrt(sqrDist);
		v /= info.dist;
		info.dir = v;
	}

	Light_Type getLightType() const { return Point_Light; }

private:
	MyAlgebra::vec3 pos;

};
