#pragma once

#include "Material.h"

class PseudoNormalColorMaterial : public Material
{
private:
	typedef MyAlgebra::vec3 vec3;
	typedef MyAlgebra::Real Real;

	PseudoNormalColorMaterial()
	{
	}

	PseudoNormalColorMaterial(const PseudoNormalColorMaterial &m)
	{
	}

public:
	static PseudoNormalColorMaterial *CreateMaterial()
	{
		PseudoNormalColorMaterial *m = new PseudoNormalColorMaterial();
		material_cache.push_back( m );
		return m;
	}

	static PseudoNormalColorMaterial *CreateMaterial(const PseudoNormalColorMaterial *_m)
	{
		PseudoNormalColorMaterial *m = new PseudoNormalColorMaterial(*_m);
		material_cache.push_back( m );
		return m;
	}

	~PseudoNormalColorMaterial()
	{
	}

	Material_Type getMaterialType() const { return Diffuse_Type; }

	vec3 calcReflectedLight(
		const HitRecord &record,
		const vec3 &incomingDir,
		const vec3 &outgoingDir) const
	{
		return 0.5f * record.normal + vec3(0.5f,0.5f,0.5f);
	}

	void clone(Material **m) const { *m = new PseudoNormalColorMaterial(*this); }

};
