#pragma once

#include <limits>
#include <float.h>

// from "Realistic Ray Tracing, second ed.", p. 26

class RNG
{
public:
	RNG(unsigned long long _seed = 7564231ULL)
		: seed(_seed), mult(62089911ULL)
	{
	}

	inline float operator()()
	{
		seed = mult * seed;
		return float(seed % LLONG_MAX) / FLT_MAX;
	}

private:
	unsigned long long seed;
	unsigned long long mult;
};