#pragma once

#include "ImageRect.h"
#include "Ray.h"
#include "Sampler.h"
#include "Filter.h"

class Camera;
class Scene;

class RayTracer
{
public:
	RayTracer()
		: m_PixelSampler(0), m_PixelFilter(0)
	{
	}

	RayTracer(const RayTracer *r)
		: m_PixelSampler(r->m_PixelSampler),
		m_PixelFilter(r->m_PixelFilter)
	{
	}

	virtual ~RayTracer()
	{
	}

	virtual MyAlgebra::vec3 trace(const Ray &ray) = 0;

	virtual void renderScene(ImageRGBf &imageBuffer) = 0;

	void registerImageSampler(Sampler *s)
	{
		//if (m_PixelSampler) delete m_PixelSampler;
		m_PixelSampler = s;
	} 

	void registerImageFilter(Filter *f)
	{
		if (m_PixelFilter) delete m_PixelFilter;
		m_PixelFilter = f;
	}

protected:
	Sampler *m_PixelSampler;
	Filter *m_PixelFilter;

};