#pragma once

#include "RayTracer.h"

class RecursiveRayTracer : public RayTracer
{
public:
	static int max_recursion_depth;
	static int s_NumSamplesPerPixel;

	static RayTracer *Create() { return new RecursiveRayTracer(); }

	RecursiveRayTracer()
		: RayTracer()
	{
	}

	RecursiveRayTracer(const RayTracer *r)
		: RayTracer(r)
	{
	}

	~RecursiveRayTracer()
	{
	}

	MyAlgebra::vec3 trace(const Ray &ray)
	{
		return traceRec(ray, 0);
	}

	void renderScene(ImageRGBf &imageBuffer);

	MyAlgebra::vec3 singleRayTrace(const ImageRGBf &imageBuffer, int xi, int yi);

private:
	ImageGrayf m_DepthImage;
	ImageGrayf m_FresnelMatte;
	ImageGrayu m_FresnelMask;

	MyAlgebra::vec3 traceRec(const Ray &ray, int recursionDepth);
	//MyAlgebra::vec3 traceRec(const Ray &ray, int recursionDepth, int prevObjectId=-1);
};
