#pragma once

#include "GeometricObject.h"

class SolidTexturedSphere : public GeometricObject
{
private:
	SolidTexturedSphere()
	{
	}

	SolidTexturedSphere(const SolidTexturedSphere &s)
		: center(s.center), radius(s.radius)
	{
		//s.material->clone(&material);
		material = s.material;
	}

	SolidTexturedSphere(MyAlgebra::vec3 &_center, MyAlgebra::Real r, Material *m)
		: center(_center), radius(r)
	{
		material = m;
	}

public:
	static SolidTexturedSphere *CreateGeometricObject()
	{
		SolidTexturedSphere *obj = new SolidTexturedSphere();
		s_GeometricObjectCache.push_back( obj );
		return obj;
	}

	static SolidTexturedSphere *CreateGeometricObject(const SolidTexturedSphere &s)
	{
		SolidTexturedSphere *obj = new SolidTexturedSphere(s);
		s_GeometricObjectCache.push_back( obj );
		return obj;
	}

	static SolidTexturedSphere *CreateGeometricObject(MyAlgebra::vec3 &_center, MyAlgebra::Real r, Material *m)
	{
		SolidTexturedSphere *obj = new SolidTexturedSphere(_center, r, m);
		s_GeometricObjectCache.push_back( obj );
		return obj;
	}

	bool hit(const Ray &r, MyAlgebra::Real tmin, MyAlgebra::Real tmax, HitRecord &record) const;
	bool shadowHit(const Ray &r, MyAlgebra::Real tmin, MyAlgebra::Real tmax) const;

	void drawGL() const;	// for preview using OpenGL

	inline MyAlgebra::vec3 getCenter() const { return center; }
	inline MyAlgebra::Real getRadius() const { return radius; }

	inline void setCenter(const MyAlgebra::vec3 &c) { center = c; }
	inline void setRadius(MyAlgebra::Real r) { radius = r; }

private:
	MyAlgebra::vec3 center;
	MyAlgebra::Real radius;

};

