#pragma once

#include "Material.h"

class SpecularRefractionMaterial : public Material
{
private:
	SpecularRefractionMaterial()
		: eta(1.33f), ks(1,1,1)
	{
	}

	SpecularRefractionMaterial(const SpecularRefractionMaterial &m)
		: eta(m.eta), ks(m.ks), Material(m)
	{
	}

public:
	static SpecularRefractionMaterial *CreateMaterial()
	{
		SpecularRefractionMaterial *m = new SpecularRefractionMaterial();
		material_cache.push_back( m );
		return m;
	}

	static SpecularRefractionMaterial *CreateMaterial(const SpecularRefractionMaterial *_m)
	{
		SpecularRefractionMaterial *m = new SpecularRefractionMaterial(*_m);
		material_cache.push_back( m );
		return m;
	}

	~SpecularRefractionMaterial()
	{
	}

	Material_Type getMaterialType() const { return Specular_Refraction_Type; }

	//MyAlgebra::vec3 calcReflectedLight(
	//	const MyAlgebra::vec3 &normal,
	//	const MyAlgebra::vec3 &incomingDir,
	//	const MyAlgebra::vec3 &outgoingDir) const
	//{
	//	return MyAlgebra::vec3();	// not used
	//}

	//void clone(Material **m) const { *m = new SpecularRefractionMaterial(*this); }

	MyAlgebra::vec3 getSpecularCoeff() const { return ks; }
	void setSpecularCoeff(const MyAlgebra::vec3 &k) { ks = k; }
	void setSpecularCoeff(MyAlgebra::Real r, MyAlgebra::Real g, MyAlgebra::Real b) { ks.set(r,g,b); }

	MyAlgebra::Real getRefractionIndex() const { return eta; }
	void setRefractionIndex(MyAlgebra::Real _eta) { eta = _eta; }

private:
	MyAlgebra::Real eta;
	MyAlgebra::vec3 ks;	// refraction

};
