#pragma once

#include <string>
#include <fstream>
#include "my_algebra.h"

class Tokenizer
{
public:
	Tokenizer(std::ifstream *pIFP)
		: m_pIFS(pIFP), m_CurrentLineNumber(1), m_ErrorFlag(false)
	{
	}

	int getCurrentLineNumber() const
	{
		return m_CurrentLineNumber;
	}

	bool skipWhiteSpaces();

	bool readToken(std::string &str);	// ELǂݎ 

	bool requireChar(char c);
	bool requireString(const std::string &str);
	bool readBoolean(bool &b);
	bool readInteger(int &i);
	bool readFloat(float &f);
	bool readVec2(MyAlgebra::vec2 &v);
	bool readVec3(MyAlgebra::vec3 &v);
	bool readVec4(MyAlgebra::vec4 &v);
	bool readFloats(float *f, int n);
	bool readString(std::string &str);	// ̂ݑΏ 
	bool readQuotedString(std::string &str);

	bool errorOccurred() const { return m_ErrorFlag; }

	bool isEndOfFile() const { return m_pIFS->eof(); }

private:
	std::ifstream *m_pIFS;
	bool m_ErrorFlag;
	int m_CurrentLineNumber;

	bool skipComments(int c);
};
