#include "TriangleMeshUniformGrid.h"
#include <cstdlib>
#include <GL/glut.h>

#include "UniformGridTraverser.h"

using namespace std;
using namespace MyAlgebra;

extern int g_CurrentXi;
extern int g_CurrentYi;

extern bool g_SingleRayDebug;
extern vector<int> g_TracedGridCells;
extern vec3 g_DebugHitPoint;

// public methods

bool TriangleMeshUniformGrid::hit(const Ray &r, Real tmin, Real tmax, HitRecord &record) const
{
	// TODO: rewrite this function

/*
	UniformGridTraverser traverser(r, m_Grid);

	bool hitTriangle = false;
	float tTmp = tmax;

	while ( traverser.isInsideGrid() )
	{
		const vector<GeometricObject *> &triangles = traverser.getCurrentCell();

		const float tCellMin = traverser.getCurrentCellTMin();
		const float tCellMax = traverser.getCurrentCellTMax();

		// for debugging
		if ( g_SingleRayDebug )
		{
			const int xCurrent = traverser.getCurrentX();
			const int yCurrent = traverser.getCurrentY();
			const int zCurrent = traverser.getCurrentZ();

			cerr << __FUNCTION__ << ": cell (" << xCurrent << "," << yCurrent << "," << zCurrent << ") added ("
			<< triangles.size() << " triangles included)" << endl; 
			g_TracedGridCells.push_back( traverser.getCurrentCellIndex() );

			cerr << __FUNCTION__ << ": cell t min/max: " << tCellMin << "/" << tCellMax << endl;
		}

		for (int ti=0; ti<(int)triangles.size(); ti++)
		{
			// do something ...
		}

		if (hitTriangle) break;

		traverser.advanceToNext();
	}

	if (hitTriangle)
	{
		record.material = material;
	}

	// for debugging
	if ( g_SingleRayDebug )
	{
		if (hitTriangle)
		{
			const int xCurrent = traverser.getCurrentX();
			const int yCurrent = traverser.getCurrentY();
			const int zCurrent = traverser.getCurrentZ();

			cerr << __FUNCTION__ << ": hit point found at cell(" << xCurrent << "," << yCurrent << "," << zCurrent << ")" << endl;
		}
		else
		{
			cerr << __FUNCTION__ << ": intersection NOT FOUND" <<endl;
		}
	}

	return hitTriangle;
*/

	return false;
}

bool TriangleMeshUniformGrid::shadowHit(const Ray &r, Real tmin, Real tmax) const
{
	// TODO: rewrite this function

/*
	UniformGridTraverser traverser(r, m_Grid);

	while ( traverser.isInsideGrid() )
	{
		const vector<GeometricObject *> &triangles = traverser.getCurrentCell();

		for (int ti=0; ti<(int)triangles.size(); ti++)
		{
			// do something ...
		}

		traverser.advanceToNext();
	}
*/

	return false;
}

void TriangleMeshUniformGrid::drawGL() const	// for preview using OpenGL
{
	for (int i=0; i<(int)m_Triangles.size(); i++)
	{
		m_Triangles[i].drawGL();
	}

	glLineWidth(1.f);
	glColor3f(0,0,0);

	m_Grid.drawWireframe();
}

void TriangleMeshUniformGrid::computeBoundingBox()
{
	m_BoundingBoxPos[0].set(  100000.f );
	m_BoundingBoxPos[1].set( -100000.f );

	for (int i=0; i<(int)m_Triangles.size(); i++)
	{
		const vec3 v0 = m_Triangles[i].getVertex0();
		const vec3 v1 = m_Triangles[i].getVertex1();
		const vec3 v2 = m_Triangles[i].getVertex2();

		m_BoundingBoxPos[0].x = min(m_BoundingBoxPos[0].x, min(v0.x, min(v1.x, v2.x)));
		m_BoundingBoxPos[0].y = min(m_BoundingBoxPos[0].y, min(v0.y, min(v1.y, v2.y)));
		m_BoundingBoxPos[0].z = min(m_BoundingBoxPos[0].z, min(v0.z, min(v1.z, v2.z)));

		m_BoundingBoxPos[1].x = max(m_BoundingBoxPos[1].x, max(v0.x, max(v1.x, v2.x)));
		m_BoundingBoxPos[1].y = max(m_BoundingBoxPos[1].y, max(v0.y, max(v1.y, v2.y)));
		m_BoundingBoxPos[1].z = max(m_BoundingBoxPos[1].z, max(v0.z, max(v1.z, v2.z)));
	}	
}

void TriangleMeshUniformGrid::buidGrid(int nXCells, int nYCells, int nZCells)
{
	if ( ! m_Grid.init(m_BoundingBoxPos[0], m_BoundingBoxPos[1], nXCells, nYCells, nZCells) )
	{
		cerr << __FUNCTION__ << ": grid cannot build" << endl;
		return;
	}

	for (int ti=0; ti<(int)m_Triangles.size(); ti++)
		m_Grid.addObject( &m_Triangles[ti] );

	cerr << __FUNCTION__ << ": " << (int)m_Triangles.size() << " triangles added" << endl;
}

