#include <iostream>
#include "UniformGridTraverser.h"

using namespace std;
using namespace MyAlgebra;

extern bool g_SingleRayDebug;

UniformGridTraverser::UniformGridTraverser(const Ray &ray, const UniformGrid &grid)
: m_pGrid(const_cast<UniformGrid *>(&grid))
{
	const vec3 &p = ray.getOrigin();
	const vec3 &d = ray.getUnitDir();

	if ( m_pGrid->isInside(p) )	// C̎n_ p Obh̓
	{
		m_CurrentTMin = 0.f;
		m_pGrid->getIndex(p, m_CurrentX, m_CurrentY, m_CurrentZ);
		calculateNextIntersectionParameters(p, d, m_CurrentTMin, m_NextTX, m_NextTY, m_NextTZ);
	}
	else	// C̎n_ p Obh̊O
	{
		float tIntersect;

		// CObhƌ邩ǂ
		if ( calculateRayBoxIntersection(tIntersect, ray) )
		{
			m_CurrentTMin = tIntersect;
			const vec3 pIntersect = ray.getPosition( tIntersect );

			m_pGrid->getIndex(pIntersect, m_CurrentX, m_CurrentY, m_CurrentZ);
			calculateNextIntersectionParameters(pIntersect, d, m_CurrentTMin, m_NextTX, m_NextTY, m_NextTZ);
		}
		else	// Ȃ΁Ago[XsȂ悤ÕZw
		{
			m_CurrentTMin = 0.f;
			m_CurrentX = m_CurrentY = m_CurrentZ = -1;
			return;
		}
	}

	const float xCellSize = m_pGrid->getXCellSize();
	const float yCellSize = m_pGrid->getYCellSize();
	const float zCellSize = m_pGrid->getZCellSize();

	// TODO: initialize the following variables:
	//   m_IncrementX, m_IncrementY, m_IncrementZ, m_DeltaTX, m_DeltaTY, and m_DeltaTZ
}

void UniformGridTraverser::advanceToNext()
{
	if (m_NextTX < m_NextTY && m_NextTX < m_NextTZ)	// m_NextTX is the smallest
	{
		m_CurrentTMin = m_NextTX;
		m_NextTX += m_DeltaTX;
		m_CurrentX += m_IncrementX;
	}
	else if (m_NextTY < m_NextTZ)	// m_NextTY is the smallest
	{
		m_CurrentTMin = m_NextTY;
		m_NextTY += m_DeltaTY;
		m_CurrentY += m_IncrementY;
	}
	else		// m_NextTZ is the smallest
	{
		m_CurrentTMin = m_NextTZ;
		m_NextTZ += m_DeltaTZ;
		m_CurrentZ += m_IncrementZ;
	}
}

void UniformGridTraverser::calculateNextIntersectionParameters(const vec3 &pIntersect, const vec3 &dir, float tStart, float &nextTX, float &nextTY, float &nextTZ) const
{
	const vec3 bboxMin = m_pGrid->getBboxMin();
	const vec3 bboxMax = m_pGrid->getBboxMax();

	const float xCellSize = m_pGrid->getXCellSize();
	const float yCellSize = m_pGrid->getYCellSize();
	const float zCellSize = m_pGrid->getZCellSize();

	// TODO: compute nextTX, nextTY, and nextTZ.
	// tStart is the ray parameter when the ray hits (enters) the bounding box of the grid.
}

// implements Ray-Box Intersection Algorithm described in http://www.cs.utah.edu/~awilliam/box/

bool UniformGridTraverser::calculateRayBoxIntersection(float &tIntersect, const Ray &ray) const
{
	// TODO: rewrite this function. First implement AxisAlignedBox::shadowHit(), copy and modify the code,
	// and then compute tIntersect as the ray parameter at the hit point.

	return false;
}

